using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using DroidExplorer.Configuration.Net;
using DroidExplorer.Configuration;
//using DroidExplorer.Configuration;

namespace DroidExplorer.Core.UI {
	public partial class GenericDeviceSelectionForm : Form {
		List<string> devices = null;
		public GenericDeviceSelectionForm ( ) {
			InitializeComponent ( );
			SelectedDevice = String.Empty;
			RefreshDevices ( );
		}

		private ListViewGroup DevicesGroup { get; set; }
		private ListViewGroup OtherGroup { get; set; }

		public string SelectedDevice { get; set; }

		private void RefreshDevices ( ) {
			// BUG: 15695
			// TODO: Fix this:
			// this is a pain in the ass bug. for some reason it will not get the devices the first time.
			// the shell call actually returns that there are no devices attached.
			devices = CommandRunner.Instance.GetDevices ( );
			devicesList.Items.Clear ( );

			// the default device type
			String model = "[DEFAULT]";

			DevicesGroup = new ListViewGroup ( "Devices", "Devices" );
			OtherGroup = new ListViewGroup ( "Other", "Other" );

			devicesList.Groups.Add ( OtherGroup );
			devicesList.Groups.Add ( DevicesGroup );


			// get the device icons for the devices
			// get the default image
			var fi = CloudImage.Instance.GetImage ( model );
			if ( fi.Exists ) {
				Image img = Image.FromFile ( fi.FullName );
				imageList.Images.Add ( Path.GetFileNameWithoutExtension ( fi.Name ), img );
			}

			devices.ForEach ( d => {
				try {
					// get the image for each device
					model = CommandRunner.Instance.GetProperty ( d, "ro.product.device", "ro.product.model", "ro.product.name", "ro.cm.device" );
					fi = CloudImage.Instance.GetImage ( model );
					if ( fi.Exists ) {
						Image img = Image.FromFile ( fi.FullName );
						imageList.Images.Add ( Path.GetFileNameWithoutExtension ( fi.Name ), img );
					}
				} catch ( Exception e ) {
					this.LogWarn ( e.ToString ( ) );
					model = "[DEFAULT]";
				}

				ListViewItem lvi = new ListViewItem ( KnownDeviceManager.Instance.GetDeviceFriendlyName ( d ), model, DevicesGroup );
				lvi.Tag = d;
				devicesList.Items.Add ( lvi );
			} );
		}

		private void helpVideoLink_LinkClicked ( object sender, LinkLabelLinkClickedEventArgs e ) {
			Process.Start ( "http://bit.ly/bZgyFK" );
		}

		private void devicesList_DoubleClick ( object sender, EventArgs e ) {
			if ( devicesList.SelectedItems.Count == 1 ) {
				var lvi = devicesList.SelectedItems[0];
				if ( lvi.Tag != null ) {
					this.SelectedDevice = (String)lvi.Tag;
				} else {
					this.SelectedDevice = lvi.Text;
				}
				DialogResult = DialogResult.OK;
			}
		}

		private void refreshToolStripButton_Click ( object sender, EventArgs e ) {
			RefreshDevices ( );
		}
	}
}
