using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace DroidExplorer.Core {
	public class DeviceListCommandResult : CommandResult {
		List<string> _devices = null;
		Dictionary<string, string> _states = null;
		public DeviceListCommandResult ( string data )
			: base ( ) {
			Devices = new List<string> ( );
			States = new Dictionary<string, string> ( );
			ProcessData ( data );
		}

		public List<string> Devices {
			get { return this._devices; }
			private set { this._devices = value; }
		}

		public Dictionary<string, string> States {
			get { return this._states; }
			private set { this._states = value; }
		}

		protected override void ProcessData ( string data ) {
			base.ProcessData ( data );
			Regex regex = new Regex ( Properties.Resources.DeviceListRegexPattern, RegexOptions.Multiline | RegexOptions.Compiled | RegexOptions.IgnorePatternWhitespace | RegexOptions.IgnoreCase );
			Match m = regex.Match ( data );
			while ( m.Success ) {
				string sn = m.Groups[1].Value;
				if ( !string.IsNullOrEmpty ( sn ) ) {
					Devices.Add ( sn.Trim ( ) );
					States.Add ( sn, m.Groups[2].Value.Trim ( ) );
				}
				m = m.NextMatch ( );
			}
			Devices.Sort ( );

		}
	}

}
