﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;
using DroidExplorer.Core;
using DroidExplorer.Core.Components;
using DroidExplorer.Core.Market;

namespace DroidExplorer.Plugins.Market {
  public class AndapkMarket : IMarketSource {
    #region IMarketSource Members

    public string Name { get { return "Anda.pk"; } }

    public Uri Url {
      get { return new Uri ( "http://anda.pk" ); }
    }

    public IWebProxy Proxy { get; set; }
    public List<MarketApplication> GetApplications ( ) {
      List<MarketApplication> apps = new List<MarketApplication> ( );
      try {
      HttpWebRequest req = HttpWebRequest.Create ( this.Url ) as HttpWebRequest;
      if ( Proxy != null ) {
        req.Proxy = Proxy;
      }
      req.Referer = this.Url.ToString ( );
      Version v = this.GetType ( ).Assembly.GetName ( ).Version;
      req.UserAgent = string.Format ( "DroidExplorer/{1}({0},http://de.codeplex.com)", v.ToString ( ), v.Major.ToString ( ) );

      HttpWebResponse resp = req.GetResponse ( ) as HttpWebResponse;
      StringBuilder sb = new StringBuilder ( );
      using ( StreamReader sr = new StreamReader ( resp.GetResponseStream ( ) ) ) {
        while ( !sr.EndOfStream ) {
          sb.AppendLine ( sr.ReadLine ( ) );
        }
      }

      Regex regex = new Regex ( Properties.Resources.AndapkInfoRegexPattern, RegexOptions.Compiled | RegexOptions.IgnoreCase | RegexOptions.IgnorePatternWhitespace | RegexOptions.Multiline );
      Match m = regex.Match ( sb.ToString ( ) );
      while ( m.Success ) {
        MarketApplication ma = new MarketApplication ( m.Groups[ 2 ].Value, m.Groups[ 3 ].Value, m.Groups[ 4 ].Value, new Uri ( m.Groups[ 1 ].Value ), DateTime.Now, 0, 0 );
        apps.Add ( ma );
        m = m.NextMatch ( );
      }
      apps.Sort ( new MarketApplicationNameComparer() );
      } catch (Exception ex ) {
        this.LogError ( ex.Message, ex );
      } 
      return apps;
    }

    #endregion
  }
}
