﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
using System.Globalization;
using DroidExplorer.Core.Plugins;
using System.Drawing;
using DroidExplorer.Core;
using DroidExplorer.Configuration;

namespace DroidExplorer.Plugins {
  public static class PluginLoader {

    public static DroidExplorer.Core.IO.LinuxDirectoryInfo CurrentPath { get; set; }
    public static IPluginHost PluginHost { get; private set; }

    public static void Load ( IPluginHost host, ToolStrip pluginToolStrip, ToolStripMenuItem pluginMenu ) {

      PluginHost = host;
      Program.LoadedPlugins.Clear ( );

      Assembly asm = typeof ( PluginLoader ).Assembly;

      List<IPlugin> plugins = Settings.Instance.PluginSettings.GetPlugins ( host );
      foreach ( IPlugin plugin in plugins ) {
        PluginInfo pluginInfo = Settings.Instance.PluginSettings.GetPluginInfo ( plugin );
        if ( pluginInfo.Enabled ) {
          Program.LoadedPlugins.Add ( plugin );
          if ( plugin.CreateToolButton ) {
						var tsb = plugin.CreateToolStripButton ( );
						var tsm = plugin.CreateToolStripMenuItem (  );

            pluginToolStrip.Items.Add ( tsb );
            pluginMenu.DropDownItems.Add ( tsm );
            if ( pluginInfo.ExecuteOnLoad ) {
              plugin.Execute ( host );
            }
          }
        }
      }

      pluginToolStrip.Visible = pluginToolStrip.Items.Count > 0;
    }


  }
}
